import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.sql.*;
import java.text.*;
/**
 * Clase Model para Factura a ser usada en JTable
 * 
 * En Confirmar/Pagar Factura
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FacturaModel extends AbstractTableModel  {
    // instance variables - replace the example below with your own
    private java.util.List<FacturaQuery> lst = new ArrayList<FacturaQuery>();
    private String query = null;

    /**
     * Constructor for objects of class FacturaModel
     */
    public FacturaModel() {
        // initialise instance variables
        this("SELECT F.NRO, F.FECHA, C.IDC, C.DESCR, F.CONFIRMADA, F.PAGADA, F.MONTO "+
             "FROM TBL_FACTURA F INNER JOIN TBL_CLIENTE C ON F.CLIENTE = C.IDC "+
             "WHERE F.CONFIRMADA = 'N' ORDER BY F.NRO ASC");
    }
    public FacturaModel(final String sql) {
        query = sql;
        actualizar();
    }
    public void actualizar() {
        try {
            lst.clear();
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet(query);
            SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
            while(rs.next()) {
                FacturaQuery fq = new FacturaQuery();
                fq.nro = rs.getInt("nro");
                fq.fecha = sdf.format(rs.getDate("fecha"));
                fq.idc = rs.getInt("idc");
                fq.descr = rs.getString("descr");
                fq.confirmada = rs.getString("confirmada");
                fq.pagada = rs.getString("pagada");
                fq.monto = rs.getDouble("monto");
                lst.add(fq);
            }
            f.close(rs);
            fireTableDataChanged();
        } catch(SQLException sqle) {
        }
    }
    // METODOS QUE PODEMOS SOBRE-ESCRIBIR AbstractTableModel
    public Class<?> getColumnClass(int columnIndex) {
        switch(columnIndex) {
            case 0: // nro
                return Integer.class;
            case 1: // fecha
                return String.class;
            case 2: // descr
                return String.class;
            case 3: // conf
                return String.class;
            case 4: // pag
                return String.class;
            case 5: // monto
                return Double.class;
        }
        return  Object.class;
    }
    public String getColumnName(int column) {
        switch(column) {
            case 0: // nro
                return "Nro";
            case 1: // fecha
                return "Fecha";
            case 2: // descr
                return "Cliente";
            case 3: // confirmada
                return "Conf.";
            case 4: // pagada
                return "Pago";
            case 5: // monto
                return "Monto";
        }
        return "";
    }
    public boolean isCellEditable(int rowIndex,int columnIndex) {
        return false;
    }
    // METODOS ABSTRACTOS OBLIGATORIOS QUE DEBEMOS IMPLEMENTAR
    public int getRowCount() {
        return lst.size(); // la cantidad de elementos que tiene lst
    }
    public int getColumnCount() {
        return 6; // porque detalle tiene 5 atributos: idp,descr,cantidad,precio,subtotal
    }
    public Object getValueAt(int row, int column) {
        FacturaQuery c = lst.get(row);
        switch(column) {
            case 0: // nro
                return c.nro;
            case 1: // fecha
                return c.fecha;
            case 2: // descr
                return c.descr;
            case 3: // conf
                return c.confirmada;
            case 4: // pag
                return c.pagada;
            case 5:
                return c.monto;
        }
        return  null;
    }
    // CUSTOM
    public FacturaQuery getFacturaQuery(int row) {
        return lst.get(row);
    }
}


