import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.text.*;
import java.sql.*;
/**
 * Vista correspondiente a la creacion de Factura
 * 
 * @author G. Cherencio
 * @version 1.0
 */
public class FacturaView extends JPanel {
    private JLabel lblmsg = null;
    private JLabel lblnro = new JLabel("Nro");
    private JLabel lblfec = new JLabel("Fecha");
    private JLabel lblcli = new JLabel("Cliente");
    private JLabel lbltot = new JLabel("Total");
    private JLabel lblpro = new JLabel("Producto");
    private JTextField txtfec = new JTextField();
    private JTextField txtnro = new JTextField();
    private JTextField txttot = new JTextField("0.0");
    private JComboBox<String> cbocli = new JComboBox<String>();
    private JComboBox<String> cbopro = new JComboBox<String>();
    private JButton btnOk = new JButton("Crear Factura");
    private JButton btnPr = new JButton("*");
    private JButton btnIn = new JButton("+");
    private JButton btnDe = new JButton("-");
    private DetalleModel dm = new DetalleModel(cbopro,txttot,this);
    private JTable tbl = new JTable(dm);
    private JScrollPane sp = new JScrollPane(tbl,
                    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);    
    
    /**
     * Constructor for objects of class FacturaView
     */
    public FacturaView() {
    }
    public FacturaView(JLabel lmsg) {
        lblmsg = lmsg;
        lblmsg.setText("Creacion de Factura!");

        dm.setJTable(tbl);
       
        btnIn.setToolTipText("Agrega Linea Factura");
        btnDe.setToolTipText("Quita Linea Factura");
        btnPr.setToolTipText("Cambia Linea Factura");
        txtfec.setEnabled(false);
        txtnro.setEnabled(false);
        txttot.setEnabled(false);
        txtnro.setBackground(Color.black);
        txtfec.setBackground(Color.black);
        txttot.setBackground(Color.black);
        
        cbocli.setModel(new DefaultComboBoxModel<String>());
        cbopro.setModel(new DefaultComboBoxModel<String>());
        setFecha(); // fecha actual en formato dd/mm/yyyy
        setNro(); // ultimo nro de factura + 1
        setCboCli(); // cargo combo de clientes
        setCboPro(); // cargo combo de productos
        // armo interfaz grafica
        setLayout(new BorderLayout());
        JPanel psup = new JPanel();
        psup.add(lblnro);
        psup.add(txtnro);
        psup.add(lblfec);
        psup.add(txtfec);
        psup.add(lblcli);
        psup.add(cbocli);
        JPanel pinf = new JPanel();
        pinf.add(lbltot);
        pinf.add(txttot);
        pinf.add(btnIn);
        pinf.add(btnDe);
        pinf.add(lblpro);
        pinf.add(cbopro);
        pinf.add(btnPr);
        pinf.add(btnOk);
        add(psup,BorderLayout.NORTH);
        add(sp,BorderLayout.CENTER);
        add(pinf,BorderLayout.SOUTH);
        // agrego eventos
        btnPr.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // debe haber una fila seleccionada en Detalle
                if ( tbl.getSelectedRow() != -1 ) {
                    Detalle d = dm.getDetalle().get(tbl.getSelectedRow());
                    String sprod = (String) cbopro.getSelectedItem();
                    int ppos = sprod.indexOf("(");
                    String sdescr = sprod.substring(0,ppos).trim();
                    int ppos2 = sprod.indexOf(")",ppos+1);
                    int idp = new Integer(sprod.substring(ppos+1,ppos2));
                    ppos = sprod.lastIndexOf("(");
                    ppos2 = sprod.lastIndexOf(")");
                    double precio = new Double(sprod.substring(ppos+1,ppos2));
                    Producto p = new Producto(idp,sdescr,precio);
                    d.setProducto(p);
                    dm.actualizar();
                }
            }
        });
        btnOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // crear nueva factura como no confirmada y no pagada
                if ( dm.getDetalle().size() == 0 ) {
                    JOptionPane.showMessageDialog(null,"La Factura debe tener al menos un producto!","Crear Factura", 
                        JOptionPane.ERROR_MESSAGE);                    
                    return;
                }
                try {
                    FBCon f = FBCon.getFBCon(0);
                    f.getConnection().commit();
                    setNro(); // ultimo nro de factura + 1, por las dudas que haya cambiado el numero
                    setFecha();
                    SimpleDateFormat sdf = new SimpleDateFormat("dd-MMM-yyyy",Locale.US);
                    String sfecha = sdf.format(new java.util.Date());
                    String scli = (String) cbocli.getSelectedItem();
                    int ppos = scli.indexOf("(");
                    int ppos2 = scli.indexOf(")");
                    int ncli = new Integer(scli.substring(ppos+1,ppos2));
                    System.out.println("INSERT INTO TBL_FACTURA(NRO,FECHA,CLIENTE,CONFIRMADA,PAGADA,MONTO) VALUES("+
                        txtnro.getText()+",'"+sfecha+"',"+ncli+",'N','N',"+txttot.getText()+")");
                    f.executeQuery("INSERT INTO TBL_FACTURA(NRO,FECHA,CLIENTE,CONFIRMADA,PAGADA,MONTO) VALUES("+
                        txtnro.getText()+",'"+sfecha+"',"+ncli+",'N','N',"+txttot.getText()+")");
                    for(Detalle d : dm.getDetalle()) {
                        System.out.println("INSERT INTO TBL_DETALLE(NRO,IDP,CANTIDAD,PRECIO) VALUES("+
                            txtnro.getText()+","+d.getProducto().getIdp()+","+d.getCantidad()+","+
                            d.getPrecio()+")");
                        f.executeQuery("INSERT INTO TBL_DETALLE(NRO,IDP,CANTIDAD,PRECIO) VALUES("+
                            txtnro.getText()+","+d.getProducto().getIdp()+","+d.getCantidad()+","+
                            d.getPrecio()+")");
                    }
                    f.getConnection().commit();
                    JOptionPane.showMessageDialog(null,"Factura:"+txtnro.getText()+" Creada Ok!",
                        "Crear Factura", JOptionPane.INFORMATION_MESSAGE);
                    setNro();
                    dm.getDetalle().clear();
                    dm.actualizar();
                    txttot.setText("0.0");
                } catch(SQLException sqle) {
                    JOptionPane.showMessageDialog(null,"Error SQL Creando Factura:"+sqle.getMessage(),
                        "Crear Factura", JOptionPane.ERROR_MESSAGE);                    
                }
            }
        });
        btnIn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // agregar linea factura
                dm.agregar();
            }
        });
        btnDe.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                // borrar linea de factura
                dm.borrar();
            }
        });

    }
    private void setFecha() {
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        txtfec.setText(sdf.format(new java.util.Date()));
    }
    private void setNro() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT COALESCE(MAX(NRO),0)+1 AS NRO FROM TBL_FACTURA");
            if(rs.next()) {
                txtnro.setText(""+rs.getInt("nro"));
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
    private void setCboCli() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT DESCR || ' (' || IDC || ')' AS DESCR FROM TBL_CLIENTE ORDER BY DESCR ASC");
            cbocli.removeAllItems();
            while(rs.next()) {
                cbocli.addItem(rs.getString("descr"));
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
    private void setCboPro() {
        try {
            FBCon f = FBCon.getFBCon(0);
            ResultSet rs = f.getResultSet("SELECT DESCR || ' (' || IDP || ')' AS DESCR,PRECIO FROM TBL_PRODUCTO ORDER BY DESCR ASC");
            cbopro.removeAllItems();
            DecimalFormatSymbols ds = new DecimalFormatSymbols(Locale.getDefault());
            ds.setDecimalSeparator('.');
            DecimalFormat df = new DecimalFormat("#######0.00",ds);            
            df.setMaximumFractionDigits(2);
            df.setMinimumIntegerDigits(2);
            df.setGroupingUsed(false);
            while(rs.next()) {
                cbopro.addItem(rs.getString("descr")+"("+df.format(rs.getDouble("precio"))+")");
            }
            f.close(rs);
        } catch(SQLException sqle) {
            // Error recuperando clientes de la base de datos
            System.err.println("FacturaView: Error, "+sqle.getMessage());
            lblmsg.setText(sqle.getMessage());
        }
    }
}
